import os
from zLOG import LOG, INFO, PANIC, register_subsystem
register_subsystem('STORAGE')
# Zope readonly allowed only for ZODB in this version
if os.environ.has_key('ZOPE_STORAGE') :
    type_storage = os.environ['ZOPE_STORAGE']
    read_only = os.environ.has_key('ZOPE_READONLY') and os.environ['ZOPE_READONLY']=='1'
    if os.environ['ZOPE_STORAGE'][0:3]=='BSD' :
        try :
            if type_storage[0:3] == 'BSD' :
                if type_storage == 'BSDPackless' :
                    from bsddb3Storage.Packless import Packless as ConcreteStorage
                elif type_storage == 'BSDMinimal' :
                    from bsddb3Storage.Minimal import Minimal as ConcreteStorage
                elif type_storage in ('BSDFull','BSD'):
                    from bsddb3Storage.Full import Full as ConcreteStorage
                else :
                    raise ValueError, 'Unknown BSD storage type "%s"' % type_storage[3:]
        except ImportError :
            LOG('STORAGE',PANIC,"Storage %s does't installed correctly")
            raise ImportError,"Storage %s does't installed correctly"
        env = os.path.join('var', 'bsddb3Storage')
        name = 'BerkeleyStorage (%s)' % type_storage[3:]        
        Storage = ConcreteStorage(name=name, env=env)
        LOG("STORAGE",INFO,'Open "%s" BSD (%s) DB at %s' % (name,type_storage[3:],env))
    elif type_storage == 'ZODB' :
        import Globals, ZODB.FileStorage
        name='%s/Data.fs' % Globals.data_dir # Globals.BobobaseName,
        Storage=ZODB.FileStorage.FileStorage(name,read_only=read_only)
        LOG("STORAGE",INFO,'Open ZODB at %s' % (name))
    else :
        raise ValueError, 'Unknown storage type "%s"' % type_storage

    if read_only :
        import ZODB.DemoStorage
        Storage=ZODB.DemoStorage.DemoStorage("Demo (%s)" % name,Storage)
        LOG("STORAGE",INFO,'Storage will be used in read only mode')
else :
    LOG('STORAGE',PANIC,"Storage definition not found, default mounting procedure will be do (See fine manual...)")
    import Globals,ZODB.FileStorage
    DB=ZODB.FileStorage.FileStorage(Globals.BobobaseName)
    DB=ZODB.DB(DB)
